/*Class name: Xml_Serializer
 *Namespace: DVM_Management_Center.FileIO
 *Author: Harald Gsoedl
 *Changed: 26/12/2006
 *Use: Provides routines to store object information in XML files.
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.IO;


namespace DVM_Management_Center.FileIO
{
    /// <summary>
    /// Provides routines to export Config-Files as an XML-File
    /// </summary>
    class Xml_Serializer
    {
        XmlSerializer xmlSer;
        FileStream fileStream;
        String fileName;
        public Xml_Serializer(String fileName)
        {
            this.fileName = fileName;
        }

        public void SerializeObject(Object obj)
        {
            xmlSer = new XmlSerializer(obj.GetType());
            fileStream = new FileStream(fileName, FileMode.Create);
            xmlSer.Serialize(fileStream, obj);
            fileStream.Close();
        }

        public object DeserializeObject(Type type)
        {
            Object obj;
            try
            {
                xmlSer = new XmlSerializer(type);
                fileStream = new FileStream(this.fileName, FileMode.Open);
                obj = xmlSer.Deserialize(fileStream);
                fileStream.Close();
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
            return obj;
        }
    }
}
