using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.IO;

using DVM_Management_Center.FileIO;
using DVM_Management_Center.Objects;

namespace DVM_Management_Center.GUI
{
    public partial class ConfigMap : Form
    {
        const String START_FILE = "/start.conf";
        private MAPObject _mapObject;
        public MAPObject MapObject
        {
            get { return _mapObject; }
            set 
            { 
                _mapObject = value;
                tbImage.Text = _mapObject.ImgFile;
            }
        }

        private String _mapFile;
        public String MapFile
        {
            get { return _mapFile; }
            set { _mapFile = value; }
        }

        public ConfigMap()
        {
            InitializeComponent();
        }

        private void btCloseClick(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btSetDVMs_Click(object sender, EventArgs e)
        {
            ConfigSite confSite = new ConfigSite();
            if(_mapObject.DVMObjects == null)
                confSite.DVMObjects = new DVMObject[0];
            else
                confSite.DVMObjects = _mapObject.DVMObjects;
            confSite.ImgFile = tbImage.Text;
            confSite.ShowDialog();
            _mapObject.DVMObjects = confSite.DVMObjects;
        }

        private void tbImage_TextChanged(object sender, EventArgs e)
        {
            if (tbImage.Text != String.Empty)
                btSetDVMs.Enabled = true;
            else
                btSetDVMs.Enabled = false;
        }

        private void btImage_Click_1(object sender, EventArgs e)
        {
            OFFF.OpenFileFromFolder offf = new OFFF.OpenFileFromFolder();
            offf.Folder = "img";
            offf.Filter = "Bitmap, Gif, JPEG files|*.bmp;*.gif;*.jpg";
            if (offf.ShowDialog() == DialogResult.OK)
            {
                tbImage.Text = offf.Folder + offf.FileName;
            }
        }

        private void btSetDVMs_Click_1(object sender, EventArgs e)
        {
            ConfigSite confSite = new ConfigSite();
            if (_mapObject.DVMObjects == null)
                confSite.DVMObjects = new DVMObject[0];
            else
                confSite.DVMObjects = _mapObject.DVMObjects;
            confSite.ImgFile = tbImage.Text;
            confSite.ShowDialog();
            _mapObject.DVMObjects = confSite.DVMObjects;
        }

        private void btSave_Click_1(object sender, EventArgs e)
        {
            if (tbImage.Text != String.Empty)
            {
                _mapObject.ImgFile = tbImage.Text;
                _mapObject.StartUpMap = cbStartUp.Checked;
                this.DialogResult = DialogResult.OK;
            }
            else
                MessageBox.Show("You must set a background-image!");
        }

        private void btSetStartUp_Click_1(object sender, EventArgs e)
        {
            cbStartUp.Checked = true;
        }

        private void tbImage_TextChanged_1(object sender, EventArgs e)
        {
            if (tbImage.Text != String.Empty)
                btSetDVMs.Enabled = true;
            else
                btSetDVMs.Enabled = false;
        }

        private void ConfigMap_Load(object sender, EventArgs e)
        {
            try
            {
                String[] info = File.ReadAllLines(Application.StartupPath + START_FILE);
                if (_mapFile == info[0] || _mapObject.StartUpMap)
                    cbStartUp.Checked = true;
            }
            catch(Exception)
            {
                cbStartUp.Checked = false;
            }
        }
    }
}