/*Class name: RegExpressions
 *Namespace: DVM_Management_Center
 *Author: Harald Gsoedl
 *Changed: 16/05/2005
 *Use: Class for regular expressions functionality.
 */

using System;
using System.Collections;
using System.Text.RegularExpressions;

namespace DVM_Management_Center.GUI
{
	/// <summary>
    /// Class for Regular Expressions Access.
	/// </summary>
	public class RegExpressions
	{
		public RegExpressions()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		/// <summary>
        /// Returns ArrayList of matches
		/// </summary>
		/// <param name="content"></param>
		/// <param name="regEx"></param>
		/// <returns></returns>
		public ArrayList GetSearchResult(string content, string regEx)
		{
			Regex rx = new Regex(regEx);
			MatchCollection res = rx.Matches(content);

			ArrayList retStrings = new ArrayList();
			foreach ( object o in res )
			{
				retStrings.Add(o.ToString());
			}
			return retStrings;
		}

		/// <summary>
        /// Returns string array of substrings divided by "split" in the original source "content"
		/// </summary>
		/// <param name="content"></param>
		/// <param name="split"></param>
		/// <returns></returns>
		public string[] GetSplitResult(string content, string split)
		{
			Regex rx = new Regex(split);
			string[] splitRes = rx.Split(content);
			
			return splitRes;
		}
	}
}
